import java.util.concurrent.atomic.*;

class PetersonAtomicLock implements Lock {
    private AtomicIntegerArray enter
        = new AtomicIntegerArray(2);
    private volatile int yield;

    public void lock() {
        int me = getThreadId();
        int other = 1 - me;
        enter.set(me, 1);
        yield = me;
        while (enter.get(other) == 1 && yield == me) {}
    }

    public void unlock() {
        int me = getThreadId();
        enter.set(me, 0);
    }

    private volatile long id0 = 0;
    private int getThreadId() {
        if (id0 == 0)
            id0 = Thread.currentThread().getId();
        long me = Thread.currentThread().getId();
        return (me == id0) ? 0 : 1;
    }
}
